//#define _X86_ 1
//Dem Volk aufs Maul geschaut:
typedef unsigned char byte;
typedef unsigned short word;

#ifdef _X86_
__forceinline byte __inbyte(word a) {
 unsigned char r;
 __asm{	mov	dx,a
	in	al,dx
	mov	r,al
 };
 return r;
}
__forceinline void __outbyte(word a, byte b) {
 __asm{	mov	al,b
	mov	dx,a
	out	dx,al
 }
}
#else
#include <intrin.h>
#endif

extern "C"{
#include <ntddk.h>
}

#define VDONGLE_TYPE 40000
#define CTL0 CTL_CODE(VDONGLE_TYPE,0x0800,METHOD_BUFFERED,FILE_READ_ACCESS)
#define CTL1 CTL_CODE(VDONGLE_TYPE,0x0FFF,METHOD_BUFFERED,FILE_READ_ACCESS)
#define CTL_MASK (CTL0^CTL1)

struct TAccessCounter{	/* Zähler für die Statistik */
 ULONG out;	/* OUT-Zugriffe */
 ULONG in;	/* IN-Zugriffe */
 ULONG fail;	/* Nicht gefunden ODER Nicht unterstützter IO-Befehl */
 ULONG resv;
};

struct TFileStatistics{	/* Datei-Info */
 ULONG fs_out;
 ULONG fs_in;
};

struct DIOCPARAMS{	/* IOCTL-Parameter */
 ULONG dwIoControlCode;
 PVOID lpvInBuffer;
 ULONG cbInBuffer;
 PVOID lpvOutBuffer;
 ULONG cbOutBuffer;
 ULONG cbBytesReturned;			/* hier: kein Zeiger! */
 void PutResult(size_t data, size_t datalen);
 NTSTATUS ctrl();
};

/***********************
 ** Globale Variablen **
 ***********************/
static ULONG PortBase=0x378;	/* Portadresse der Emulation via IOPM */
static ULONG P586Base=0x378;	/* Portadresse der Emulation via Debugreg. */
static ULONG PhysBase=0x378;	/* Physikalische Portadresse */
static ULONG KillBase=0;	/* Zu überschreibende Portadresse im BIOS */

static TAccessCounter AC;
static TFileStatistics FileSta;

static word*MemAdr;		/* Speicheradresse */
static word*MemEnd;		/* Speicherendadresse (plus 1) */
static ULONG MemAlloc;		/* momentane Seitenzahl (als Cache) */
static word*MemIdx;		/* Umlauf-Zeiger für Vergleich */
#define BUFFERLEN 2048	/* Puffer-Länge in WORDs = 4 KByte */
static word Buffer[BUFFERLEN];	/* Puffer */
/* Aufbau des Puffers:
 * 1 WORD Anzahl OUT-Befehle (Füllstand in Bytes = (Anzahl+2)*2)
 * x WORD OUT-Befehle, Lo=Byte, Hi=Offset 0..3
 * 1 WORD IN-Befehl, Lo=Byte, Hi=Offset+4 4..7 */
static byte EmuMode;		/* Emulation Aus/Wiedergabe/Aufnahme */
static byte Tick;		/* Knackgeräusch Aus/Laut/Leiser (ungenutzt) */
static byte Trap;		/* Trap-Modus Aus/IOPM/586Debug */
static byte Dirty;		/* Dirty-Flag */

static word ChangedPort;	/* zur Rücknahme des Patches beim Beenden */
static word WasAddr;
static LARGE_INTEGER OldInt1;	/* bleibt Null ohne Pentium */

static LARGE_INTEGER IDT;

static void NewInt1();
static bool MemReAlloc(size_t);

/*****************************
 ** Debug-Register und Int1 **
 *****************************/
#define USE_DA	0x0000		/* 0 oder 0x2000 */
#define PRE_ALLOC 0x100000	/* 1 MB fester Speicher beim Anlernen */

void __declspec(naked) LoadDR() {
/* Lade Debugregister, VR: EAX */
 __asm{	mov	eax,DR7
	btr	eax,13		/* zuerst: Debugregister-Trap ausschalten */
	mov	DR7,eax
	_emit	0x0F		// mov eax,cr4
	_emit	0x20
	_emit	0xE0
	BTS	eax,3		/* PENTIUM Debug Extension aktivieren */
	_emit	0x0F		// mov cr4,eax
	_emit	0x22
	_emit	0xE0
	mov	eax,[P586Base]
	mov	DR0,eax
	mov	eax,DR7
	or	eax,0x000E0303|USE_DA
	btr	eax,16	/* EAX=xxxx xxxx xxxx 1110 xxXx xx11 xxxx xx11 */
	mov	DR7,eax
	ret
 }
}

void __declspec(naked) UnloadDR() {
/* Entlade Debugregister, VR: EAX */
 __asm{	mov	eax,DR7
	and	eax,~(0x000F0003|USE_DA)
	mov	DR7,eax	/* EAX=xxxx xxxx xxxx 0000 xxXx xxxx xxxx xx00 */
	ret
 }
}

void __declspec(naked) SetHook1() {
/* PE: CX:EAX=neue Adresse für INT1 */
/* PA: CX:EAX=alte Adresse von INT1 */
 __asm{	sidt	[IDT]
	mov	edx,cr0
	push	edx
	 btr	edx,16			/* Supervisor Mode Write Protect */
	 mov	cr0,edx
	 mov	edx,[dword ptr IDT+2]
	 xchg	ax,[edx+0x08]		/* Low-Teil Offset */
	 rol	eax,16
	 xchg	ax,[edx+0x0E]		/* High-Teil Offset */
	 rol	eax,16
	 xchg	cx,[edx+0x0A]		/* Segment */
	pop	edx
	mov	cr0,edx
	ret
 }
}

void __declspec(naked) SwapID() {
 __asm{	pushfd
	pop	eax
	btc	eax,21
	push	eax
	popfd
	ret
 }
}

void GetInt1() {
/* PA: [OldInt1]=Adresse von INT1, aber nur beim Pentium */
 __asm{	call	SwapID
	mov	esi,eax
	call	SwapID
	cmp	esi,eax
	jz	no_586
	sidt	[IDT]
	mov	esi,[dword ptr IDT+2]	/* BASE */
	mov	edi,offset OldInt1
	cld
	mov	ax,[esi+0x08]		/* Low-Teil Offset */
	stosw
	mov	ax,[esi+0x0E]		/* High-Teil Offset */
	stosw
	movzx	eax,word ptr [esi+0x0A]	/* Segment */
	stosd
no_586:
 }
}

void __declspec(naked) HookInt1() {
/* Faule Annahme: bei INT1 befindet sich bereits ein gültiger Gate-Deskriptor
/* VR: EAX,CX,EDX; EFlags unverändert */
 __asm{	pushfd
	 cli
	 mov	eax,offset NewInt1
	 mov	cx,cs
	 cmp	[dword ptr OldInt1],0
	 jz	no_586
	 call	SetHook1
no_586:
	popfd
	ret
 }
}

void __declspec(naked) UnhookInt1() {
/* VR: EAX,CX,ESI; EFlags unverändert */
 __asm{	pushfd
	 cli
	 mov	eax,[dword ptr OldInt1]
	 mov	cx,[word ptr OldInt1+4]
	 cmp	[dword ptr OldInt1],0
	 jz	no_586
	 call	SetHook1
no_586:
	popfd
	ret
 }
}

/***************************
 ** Portzugriffe und Trap **
 ***************************/

bool Compare1(word*&a) {
/* Einen Stringvergleich durchführen
 * PE: a = laufende Adresse im "Mem"
 * PA: a = Adresse hinter dem verglichenen String
 *     ret = true: Vergleich OK, dann [EAX-2]=IN-Byte (außerdem im Puffer)
 */
 word*adr=a;
 unsigned l=*adr+1;	//Anzahl OUTs + Längen-WORD
 a+=l+1;		//Endadresse; neue Adresse
//nun: ESI,ECX und EDI gesetzt sowie EAX (das neue Ende) berechnet
 if (memcmp(Buffer,adr,l<<1)) return false;	// andere OUT-Bytes
 if (Buffer[l]>>8!=adr[l]>>8) return false;	// andere IN-Adresse
 Buffer[l]=adr[l];	//???
 return true;		//passt!
}

unsigned Compare2(word*&a) {
/*Noch einen Stringvergleich durchführen, diesmal wird ein
 * "Fehler-Koeffizient" geliefert, um die beste Passung zu finden
 * Der String-Vergleich wird mit den jeweils LETZTEN OUT-Befehlen gemacht//
 * eine unterschiedliche IN-Adresse liefert den maximal möglichen
 * Fehlerkoeffizient
 * PE: a = laufende Adresse im "Mem"
 * PA: a = Adresse hinter dem verglichenen String
 *     ret = Fehler-Koeffizient (je kleiner, desto besser)
 */
 word*adr=a;
 unsigned al=*adr+1;	//Anzahl OUTs + Längen-WORD
 a+=al+1;		//Endadresse; neue Adresse
 unsigned bl=Buffer[0]+1;
 if (adr[al]>>8 != Buffer[bl]>>8) return (unsigned)-1;	// falsche IN-Adresse
 int d=al-bl;
 if (d<0) d=-d;
 d*=3;			//Längenfehler mit Drei bewerten
 for(;--al&&--bl;) {
  unsigned ax=adr[al],bx=Buffer[bl];
  if ((ax&0x00FF)!=(bx&0x00FF)) ++d;	//Datenfehler mit Eins bewerten
  if ((ax&0xFF00)!=(bx&0xFF00)) d+=2;	//Adressfehler mit Zwei bewerten
 }
 return (unsigned)d;
}

bool ProcessBuffer(word&ax) {
//Routine wird bei IN-Befehl von PutInBuffer() aufgerufen
 bool r=true;
 switch (EmuMode) {
  case 1: {	// emulieren
   word*ebx=MemEnd;		//Ende ins Register EBX
   if (!ebx) return false;	//Notbremse - und Null liefern
   word*a=MemIdx, *edx=a;	//Startpunkt merken in EDX
   do{
    if (Compare1(a)) goto f;
    if (a==ebx) a=MemAdr;	//weiter von vorn
   }while(a!=edx);		//bis zum Startpunkt
   ++AC.fail;
	//vielleicht ist das Dongleabfrageprogramm schlau und doof zugleich!
	//(Schickt zufällige Daten ans Dongle und will doch immer die gleiche
	// Byte-Sequenz beim Auslesen.)
	//Oder aber im zweiten Versuch den besten Treffer finden!
	//(Das ist zeitraubender, deshalb im zweiten Versuch)
   unsigned edi=(unsigned)-1;
   word*ebp;
   do{
    unsigned ecx=Compare2(a);
    if (ecx<edi) {	//Z=1 -> HIER: Nur erstes Minimum nehmen
     edi=ecx;		//neues Minimum merken
     ebp=a;		//(End-)Adresse merken
    }
    if (a==ebx) a=MemAdr;	//Speicher-Ende erreicht? Weiter von vorn
   }while(a!=edx);		//bis zum Startpunkt
   Compare2(a);		//noch einer zum Vorrücken von a
   if (edi!=(unsigned)-1) { //Überhaupt etwas brauchbares gefunden?
    ax=ebp[-1];		//das nunmehr am besten passende IN-Byte
    if (AC.resv>edi) AC.resv=edi;//Maximum eintragen
   }else{
f:  ax=a[-1];		//"nächstes" IN-Byte liefern
   }
   if (a==ebx) a=MemAdr;	//Speicher-Ende erreicht? Weiter von vorn
   MemIdx=a;
  }break;

  case 2: {	// anlernen
   unsigned l=Buffer[0]+2;	//Anzahl WORDs
   word*edi=MemEnd;
   unsigned lw=edi-MemAdr+l;	//Anzahl Words
// Das dynamische Speicher-Vergrößern funktioniert mit NT nicht richtig!
#if 1
   if (lw>PRE_ALLOC) r=false;
#else
   r=MemReAlloc(lw);
#endif
   if (r) {
    memcpy(edi,Buffer,l<<1);
    Dirty=true;
   }else ++AC.fail;
  }break;
 }
 Buffer[0]=0;
 return r;
}

bool _fastcall PutInBuffer(word&ax) {	// Client_EAX in ecx
/* PE: AX = Client_EAX (Client_RAX)
 * PA: AL in Client_EAX geändert (bei IN-Byte im Wiedergabebetrieb)
 *     ret = true: okay, false: irgendetwas ging schief
 */
 word*si=Buffer;
 unsigned dx=*si;
 if (dx && si[dx]==ax) return true;	//Schon vorhanden? Ignorieren!
 si[++dx]=ax;				//Befehl eintragen
 if (ax&0x400) return ProcessBuffer(ax);//IN-Befehl? Weiterbearbeiten!
 if (dx>=BUFFERLEN) return false;	//Puffer voll?
 *si=dx;	//String ist länger geworden, eintragen
 return true;
}

word IOCallback2(word ax,unsigned dx) {
//fast dieselbe Routine, für den Aufruf durch den Hardwarebreakpoint
//mit dem wichtigen Unterschied, daß der I/O-Zugriff bereits gemacht wurde
//und hier KEINESFALLS ein Zugriff erfolgen darf, sonst Rekursion!
//(Ausnahme: die emulierte Portadresse ist nicht gleich der physikalischen.)
 dx-=P586Base;
 if (dx>=3) return ax;		//Die vierte Portadresse ganz ignorieren
 if (!(ax&0x0400)) {	// IN
  ++AC.in;
  if (EmuMode!=1 && PhysBase!=P586Base) {	//Wiedergabe? //unterschiedlich?
   ax=__inbyte(dx+PhysBase);	//IN-Befehl auf richtiger Adresse nachholen
  }
  ax = ax&0xFF | dx<<8 | 0x400;
 }else{
  ++AC.out;
  if (EmuMode!=1 && PhysBase!=P586Base) {	//Wiedergabe?	//unterschiedlich?
   __outbyte(dx+PhysBase,ax);		//OUT-Befehl auf richtiger Adresse nachholen
  }
 }
 PutInBuffer(ax);	//liefert false, wenn CallWindows erforderlich
 return ax;
}

void __declspec(naked) NewInt1() {
 __asm{	pushad
	pushfd
	 mov	eax,DR6
	 btr	eax,0		//Zugriff auf Portadresse..Portadresse+3?
	 jc	access
	 btr	eax,13		//Zugriff auf Debug-Register?
	 jc	accdr
	popfd
	popad
	jmp	fword ptr cs:[OldInt1]	//weiter (zu SoftICE o.ä.)
accdr:	//wenn schlimme Finger am Debugregister spielen
	popfd
	mov	DR6,eax
	call	LoadDR		//nachladen!
	popad
	iretd
access:
//bei jedem Portzugriff (LPT) steht in DX die Portadresse
//Faule Annahme: in AL steht das Datenbyte
	popfd
	mov	DR6,eax		//Bit in DR6 löschen
	mov	ebp,esp		//CRS adressierbar machen (ab EIP -4!)
	push	ds
	push	es
	 mov	di,ss
	 bt	dword ptr [ebp+0x28],17	//V86-Mode?
	 jnc	protmode
//Opcode beschaffen; Adressrechnung je nach V86- oder Protmode
	 mov	ds,di
	 movzx	eax,word ptr [ebp+0x24]	//Real-Mode-CS
	 shl	eax,4
	 add	eax,[ebp+0x20]
	 jmp	fromvm
//Annahme: Zugriff im Protected Mode mit lesbarem Code-Segment
protmode:
	 lds	eax,fword ptr [ebp+0x20] //Code-Zeiger
fromvm:
	 mov	al,[eax-1]		//Opcode
	 mov	ds,di
	 mov	es,di
//Richtung des Portzugriffs (Lesen oder Schreiben) ermitteln
	 xor	ecx,ecx
	 cmp	al,0xEC			//IN al,dx
	 je	supported		//mit AL=gelesenes Byte
	 BTS	ecx,2
	 cmp	al,0xEE			//OUT dx,al
	 je	supported		//mit AL=geschriebenes Byte
	 inc	[AC.fail]
	 jmp	no_simple_IO
supported:
	 pushad
	  mov	eax,[ebp+0x1C]		//Client_EAX
	  mov	ah,cl
	  xchg	ecx,eax
	  call	IOCallback2		//etwas anders als IOCallback!
	  mov	[ebp+0x1C],al		//Client_EAX
	 popad
no_simple_IO:
	pop	es
	pop	ds
	popad
	iretd
 }
}

/************************
 ** Speicherverwaltung **
 ************************/
const ULONG MEMPAGE=0x10000;		//hier: Speicher in 64-K-Schritten anfordern

bool MemReAlloc(size_t newsize) {
/* Suchspeicher belegen, verändern oder freigeben
 * PA: siehe Memxxx-Speicherzellen; Adresse=0 bei Fehler
 */
 if (EmuMode == 2) return false;	// Aufnahme? Nichts allozieren, sonst Absturzgefahr
 word*oldadr=MemAdr;
 size_t oldlen=MemEnd-oldadr;
 if (newsize) {
  newsize = (newsize+MEMPAGE-1)&~(MEMPAGE-1);
  if (newsize == MemAlloc) return true;
  ULONG minsize = MemAlloc;
  if (minsize > newsize) minsize = newsize;
  word*newadr=(word*)ExAllocatePool(NonPagedPool,newsize<<1);
  if (!newadr) return false;
  ULONG offset=MemIdx-oldadr;
  if (offset>=newsize) offset=0;
//  __movsd(newadr,oldadr,minsize>>2);
  memcpy(newadr,oldadr,minsize<<1);
  MemAdr=newadr;
  MemEnd=newadr+oldlen;
  MemAlloc=newsize;
  MemIdx=newadr+offset;
 }else{
  MemAdr=0;
  MemEnd=0;
  MemAlloc=0;
  MemIdx=0;
 }
 if (oldadr) ExFreePool(oldadr);
 return true;
}

/******************
 ** Datei-Arbeit **
 ******************/

bool IsConsistent() {
/* Prüft Konsistenz und entfernt Double-Outs
 * PE: [MemAdr] und [MemEnd]
 * PA: CY=0, wenn konsistent
 *     [MemAdr] und [MemEnd] ggf. verändert
 * VR: AL
 */
 word*si=MemAdr,*di=si,*bx=MemEnd;
 FileSta.fs_in=FileSta.fs_out=0;
 while (si<bx) {
  unsigned ax=*si++;
  if (ax>BUFFERLEN) return false; //Fehler - Längen-WORD zu groß!
  word&bp=*di;		//merken wo die OUT-Länge gespeichert wurde
  *di++=ax;
  FileSta.fs_in++;
  FileSta.fs_out+=ax;
  unsigned cx=ax;
  if (cx) {
   unsigned dx=(unsigned)-1;	//Vorhergehender OUT-Befehl
   do{
    ax=*si++;
    if (ax>>8>=3) return false;	//Fehler: Kein OUT-Byte
    if (ax==dx) {		//Doppel-OUT nicht schreiben
     --bp;			//ein OUT weniger!
     --FileSta.fs_out;
    }else{
     *di++=ax;
     dx=ax;			//OUT-Befehl merken
    }
   }while(--cx);
  }
  ax=*si++;			//IN-Byte
  *di++=ax;
  if (unsigned((ax>>8)-4)>=3) return false; //kein IN-Byte
 }
 if (si!=bx) return false;	//Gesamtlänge passt nicht
 if (si==di) return true;	//Reallokation (Verkleinerung) nicht erforderlich
 return MemReAlloc((di-MemAdr)<<1);	// verkleinern
}

NTSTATUS LoadFile(PCWSTR FileName,BOOLEAN append) {
 UNICODE_STRING filename;
 HANDLE hFile;
 OBJECT_ATTRIBUTES oa;
 IO_STATUS_BLOCK iosb;
 FILE_STANDARD_INFORMATION fsi;
 ULONG oldsize, newsize;

 RtlInitUnicodeString(&filename,FileName);
 InitializeObjectAttributes(&oa,&filename,OBJ_CASE_INSENSITIVE,NULL,NULL);

 ZwCreateFile(&hFile,GENERIC_READ|SYNCHRONIZE,&oa,&iosb,NULL,
   FILE_ATTRIBUTE_NORMAL,FILE_SHARE_READ,FILE_OPEN,
   FILE_SEQUENTIAL_ONLY|FILE_SYNCHRONOUS_IO_NONALERT,NULL,0);
 if (NT_SUCCESS(iosb.Status)) {
  word dkheader;
  ZwReadFile(hFile,NULL,NULL,NULL,&iosb,&dkheader,2,NULL,NULL);

  if (NT_SUCCESS(iosb.Status) && dkheader=='KD') {

   ZwQueryInformationFile(hFile,&iosb,&fsi,sizeof(fsi),FileStandardInformation);
   fsi.EndOfFile.LowPart-=2;

   oldsize=append ? MemEnd-MemAdr : 0;
   newsize=oldsize+fsi.EndOfFile.LowPart;
   MemReAlloc(newsize);
   ZwReadFile(hFile,NULL,NULL,NULL,&iosb,
     MemAdr+oldsize,fsi.EndOfFile.LowPart,NULL,NULL);
   if (NT_SUCCESS(iosb.Status) && !IsConsistent()) iosb.Status=0xC00001F1;
   if (NT_SUCCESS(iosb.Status)) {
    Dirty=append;
   }else{
    MemReAlloc(oldsize);
   }
  }else{
   iosb.Status=0xC00001F0;
  }
  ZwClose(hFile);
 }
 return iosb.Status;
}

NTSTATUS SaveFile(PCWSTR FileName) {
 UNICODE_STRING filename;
 HANDLE hFile;
 OBJECT_ATTRIBUTES oa;
 IO_STATUS_BLOCK iosb;

 RtlInitUnicodeString(&filename,FileName);
 InitializeObjectAttributes(&oa,&filename,OBJ_CASE_INSENSITIVE,NULL,NULL);

 ZwCreateFile(&hFile,FILE_WRITE_DATA|SYNCHRONIZE,&oa,&iosb,NULL,
   FILE_ATTRIBUTE_NORMAL,0,FILE_OVERWRITE_IF,
   FILE_SEQUENTIAL_ONLY|FILE_SYNCHRONOUS_IO_NONALERT,NULL,0);
 if (NT_SUCCESS(iosb.Status)) {

  word dkheader='KD';
  ZwWriteFile(hFile,0,0,0,&iosb,&dkheader,2,0,0);
  size_t lb=(MemEnd-MemAdr)<<1;

  ZwWriteFile(hFile,0,0,0,&iosb,MemAdr,lb,0,0);
  if (NT_SUCCESS(iosb.Status)) {
   if (iosb.Information==lb) {
    Dirty=0;		// okay!
   }else{
    iosb.Status=0xC00001F0;	// unvollständig!
   }
  }
  ZwClose(hFile);
 }
 return iosb.Status;
}


void SetTrap(byte NewTrap) {
 KIRQL OldIrql;
 if (Trap!=NewTrap) {
  switch (Trap) {
   case 2: {
    UnloadDR();
    UnhookInt1();
    MmPageEntireDriver(NewInt1);
   }
  }
  Trap=NewTrap;
  switch (Trap) {
   case 2: {
    MmResetDriverPaging(NewInt1);
    HookInt1();
    LoadDR();
   }
  }
 }
}

void SetEmu(byte NewEmu) {
 if (EmuMode == NewEmu) return;
 if (EmuMode == 2) {	// war: Aufnahme?
  EmuMode = NewEmu;	// <>2 setzen
  MemReAlloc(MemEnd-MemAdr);	// Auf notwendige Größe verkleinern!
 }
 if (NewEmu == 2) {	// jetzt: Aufnahme?
  size_t savelen = MemEnd-MemAdr;
  MemReAlloc(PRE_ALLOC);	// Vor-Allokation!
  MemEnd = MemAdr+savelen;
 }
 EmuMode = NewEmu;
}

/************************
 ** Nahtstellen zum NT **
 ************************/
struct REGINFO:public KEY_VALUE_FULL_INFORMATION {
 WCHAR space[255];
 inline NTSTATUS query(HANDLE key,wchar_t*us,ULONG&ResultLen) {
  UNICODE_STRING tag;
  RtlInitUnicodeString(&tag,us);
  return ZwQueryValueKey(key,&tag,KeyValueFullInformation,this,sizeof*this,
   &ResultLen);
 }
 inline void*data() {return (char*)this+DataOffset;}
};

NTSTATUS vdnt_init(UNICODE_STRING&RegPath) {
 HANDLE key;
 OBJECT_ATTRIBUTES oa;
 ULONG ResultLen;
 REGINFO info;

 GetInt1();	// INT1 sichern
 if (!OldInt1.LowPart) return 0xC00001F0;	// kein Pentium!

 InitializeObjectAttributes(&oa,&RegPath,OBJ_CASE_INSENSITIVE,NULL,NULL);

 ZwOpenKey(&key,KEY_QUERY_VALUE,&oa);

 NTSTATUS Status=info.query(key,L"Port",ResultLen);
 if (NT_SUCCESS(Status) && info.Type==REG_DWORD) {
  PhysBase=P586Base=PortBase=*(ULONG*)info.data();
 }

 Status=info.query(key,L"Phys",ResultLen);
 if (NT_SUCCESS(Status) && info.Type==REG_DWORD) {
  PhysBase=*(ULONG*)info.data();
 }

 Status=info.query(key,L"Load",ResultLen);
 if (NT_SUCCESS(Status) && info.Type==REG_SZ) {
  Status=LoadFile(PCWSTR(info.data()),false);
  if (NT_SUCCESS(Status)) {
   SetTrap(2);
   SetEmu(1);
  }
 }
 return STATUS_SUCCESS;
}

void vdnt_done() {
 SetEmu(0);
 SetTrap(0);
 MemReAlloc(0);
}

void A2U(PWSTR su, PCSZ sa, ULONG destlen) {
// ISO-Latin-1 zu Unicode konvertieren
 if (destlen) do {
  if (!(*su++ = *sa++)) break;
 }while (--destlen);
}

void DIOCPARAMS::PutResult(size_t data, size_t datalen) {
 if (cbOutBuffer>=datalen) {
  if (datalen<=4) {
   switch (cbOutBuffer) {
    case 1: *(byte*)(lpvOutBuffer)=data; break;
    case 4: *(ULONG*)(lpvOutBuffer)=data; datalen=4; break;
    default:*(word*)(lpvOutBuffer)=data; datalen=2;
   }
  }else{
   RtlCopyMemory(lpvOutBuffer,(void*)data,datalen); //hier: data=Zeiger
  }
  cbBytesReturned=datalen;
 }
}

NTSTATUS DIOCPARAMS::ctrl() {

 switch (byte(dwIoControlCode >> 8)) {

  case 0: {			//Versions-Abfrage
   PutResult(0x0200,2);
  }break;

  case 1: {			//Zugriffs-Zähler
   switch (byte(dwIoControlCode)) {
    case 0: {				//löschen
     RtlZeroMemory(&AC,sizeof(AC));
    }break;
    case 1: {				//setzen
     if (cbInBuffer>=sizeof(AC)) {
      RtlCopyMemory(&AC,lpvInBuffer,sizeof(AC));
     }
    }break;
    case 0xFF: {			//abfragen
     PutResult((ULONG)&AC,sizeof(AC));
    }break;
   }
  }break;

  case 3: {			//Emulations-Modus
   PutResult(EmuMode,1);
   switch (byte(dwIoControlCode)) {
    case 0:
    case 1:
    case 2: {				//setzen
     SetEmu(byte(dwIoControlCode));
    }break;
   }
  }break;

  case 5: {			//Datei-Funktionen
   wchar_t filename[256]=L"\\??\\";
   switch (byte(dwIoControlCode)) {
    case 0: {				//Neu
     MemReAlloc(0);
     Dirty=0;
    }break;
    case 1: {				//Load
     A2U(filename+4,(PCSZ)lpvInBuffer,252);
     return LoadFile(filename,FALSE);
    }break;
    case 2: {				//Append
     A2U(filename+4,(PCSZ)lpvInBuffer,252);
     return LoadFile(filename,TRUE);
    }break;
    case 3: {				//Save
//     __asm int 3;
     A2U(filename+4,(PCSZ)lpvInBuffer,252);
     return SaveFile(filename);
    }break;
    case 0xFE: {			//Dirty abfragen
     PutResult(Dirty,1);
    }break;
    case 0xFF: {			//Puffer-Länge in Bytes abfragen
     PutResult((MemEnd-MemAdr)<<1,4);
    }break;
   }
  }break;

  case 6: {			//Datei-Info
   PutResult((ULONG)&FileSta,sizeof(FileSta));
  }break;

  case 7: {			//Trap-Modus
   PutResult(Trap,1);
   switch (byte(dwIoControlCode)) {
    case 0:
    case 2: {				//setzen
     SetTrap(byte(dwIoControlCode));
    }break;
   }
  }break;

 }
 return STATUS_SUCCESS;
}

/*********************************************
 ** C++-Wrapper für NT-Device und NT-Driver **
 *********************************************/

struct Device:public DEVICE_OBJECT{
 inline NTSTATUS Control(IRP&);
 static NTSTATUS Control(DEVICE_OBJECT*pDO,IRP*pIrp) {return static_cast<Device*>(pDO)->Control(*pIrp);}
 inline NTSTATUS OpenClose(IRP&);
 static NTSTATUS OpenClose(DEVICE_OBJECT*pDO,IRP*pIrp) {return static_cast<Device*>(pDO)->OpenClose(*pIrp);}
};

NTSTATUS Device::Control(IRP&irp) {
 IO_STACK_LOCATION&IrpStack = *IoGetCurrentIrpStackLocation(&irp);
 DIOCPARAMS dioc={
 /*dwIoControlCode*/	(IrpStack.Parameters.DeviceIoControl.IoControlCode&CTL_MASK)>>2,
 /*lpvInBuffer*/	irp.AssociatedIrp.SystemBuffer,
 /*cbInBuffer*/		IrpStack.Parameters.DeviceIoControl.InputBufferLength,
 /*lpvOutBuffer*/	irp.AssociatedIrp.SystemBuffer,
 /*cbOutBuffer*/	IrpStack.Parameters.DeviceIoControl.OutputBufferLength};

 NTSTATUS Status=dioc.ctrl();

 irp.IoStatus.Information=dioc.cbBytesReturned; /* Anzahl Rückgabe-Bytes */
 irp.IoStatus.Status     =Status;
 IoCompleteRequest(&irp,IO_NO_INCREMENT);
 return Status;
}

NTSTATUS Device::OpenClose(IRP&irp) {
 irp.IoStatus.Information = 0;  /* Keine Rückgabe-Bytes */
 irp.IoStatus.Status = STATUS_SUCCESS;
 IoCompleteRequest(&irp,IO_NO_INCREMENT);
 return STATUS_SUCCESS;
}

struct Driver:public DRIVER_OBJECT {
 inline void Unload();
 static void Unload(DRIVER_OBJECT*p) {static_cast<Driver*>(p)->Unload();}
 inline NTSTATUS Entry(UNICODE_STRING&);
};

void Driver::Unload() {
/* Symbolischen Link wieder auflösen */
 vdnt_done();
 UNICODE_STRING Win32DeviceName;
 RtlInitUnicodeString(&Win32DeviceName,L"\\DosDevices\\VDongle.386");
 IoDeleteSymbolicLink(&Win32DeviceName);
 IoDeleteDevice(DeviceObject);
}

NTSTATUS Driver::Entry(UNICODE_STRING&RegistryPath) {
 // Symbolischen Link erzeugen, so dass Win32 darauf zugreifen kann

/* Treiber-Zeiger setzen */
 MajorFunction[IRP_MJ_CREATE]         = Device::OpenClose;
 MajorFunction[IRP_MJ_CLOSE]          = Device::OpenClose;
 MajorFunction[IRP_MJ_DEVICE_CONTROL] = Device::Control;
 DriverUnload                         = Unload;

/* Aus Treiber mache Gerät */
 UNICODE_STRING NtDeviceName;
 RtlInitUnicodeString(&NtDeviceName,L"\\Device\\VDongle");
 DEVICE_OBJECT*DeviceObject;
 NTSTATUS Status;
 Status = IoCreateDevice(this,0,&NtDeviceName,VDONGLE_TYPE,0,FALSE,
   &DeviceObject);
 if (!NT_SUCCESS(Status)) return Status;

 Status=vdnt_init(RegistryPath);
 if (!NT_SUCCESS(Status)) return Status;

/* Mache Gerät von Win32 aus sichtbar */
 UNICODE_STRING Win32DeviceName;
 RtlInitUnicodeString(&Win32DeviceName,L"\\DosDevices\\VDongle.386");
 Status = IoCreateSymbolicLink(&Win32DeviceName,&NtDeviceName);
 if (!NT_SUCCESS(Status)) IoDeleteDevice(DeviceObject);

 return Status;
}

extern "C" NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject,
				IN PUNICODE_STRING RegistryPath) {
 return static_cast<Driver*>(DriverObject)->Entry(*RegistryPath);
}
